#ifndef _DISCAMB_BASICCHEMISTRY_PERIODICTABLE_H_
#define _DISCAMB_BASICCHEMISTRY_PERIODICTABLE_H_

#include <string>
#include <vector>
#include <map>

namespace discamb {

    /**
    * \defgroup BasicChemistry BasicChemistry
    \brief Basic chemistry related utilities.
    * @{
    */

    /** \brief Periodic table related information.*/

    namespace periodic_table {

        std::string symbol(size_t atomicNumber);

        size_t atomicNumber(const std::string &symbol);

        /** S, P, D or F (lanthanides and actinides has no block assigned */
        char block(size_t atomicNumber);

        size_t period(size_t atomicNumber);

        size_t group(size_t atomicNumber);

    }
    /**@}*/

} // namespace discamb


#endif

