#ifndef _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_H_
#define _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_H_

#include <string>
//C++11 #include <memory>
#include <vector>

class Test{
public:
    virtual ~Test();
    /** run test, path - is a path to input file, if empty, a version with no path argument is called*/
    virtual bool run_test(std::string &message, const std::vector<std::string> &arguments);
    virtual bool run_test(std::string &message) = 0;
    virtual std::string test_name() const=0;
    static Test *create(const std::string &type);
    static void test_names(std::vector<std::string> &test_names);
    //C++11 static void all_tests(std::vector<std::unique_ptr<Test> > &tests);
    //C++98
    static void all_tests(std::vector<Test*>  &tests);
    void setMessageLevel(int messageLevel);
protected:
    Test();
    int mMessageLevel;
};


#endif /*_DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_H_*/
