#ifndef _DISCAMB_TESTS_CORRECTNESS_TEST_1_TESTTYPEGROUPING_H_
#define _DISCAMB_TESTS_CORRECTNESS_TEST_1_TESTTYPEGROUPING_H_
#include "Test.h"

#include "discamb/MathUtilities/Vector3.h"
#include "discamb/MathUtilities/Matrix3.h"

#include "discamb/CrystalStructure/Crystal.h"

#include <vector>
#include <complex>


class TestTypeGrouping: public Test
{
public:
    TestTypeGrouping();
    virtual ~TestTypeGrouping();
    virtual bool run_test(std::string &message);
    //virtual bool run_test(std::string &message, const std::string &directory);

    virtual std::string test_name() const { return std::string("TypeGrouping"); };

    double compare(const std::string &xdMas, const std::string &xdPar);
private:
    std::vector<discamb::Vector3i> mHkl;
    void populateHkl();
    double mRFactorThreshold;
    
};

#endif /*_DISCAMB_TESTS_CORRECTNESS_TEST_1_TESTTYPEGROUPING_H_*/
