#ifndef _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_CPUGPU_H_
#define _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_CPUGPU_H_
#include "Test.h"
#include "discamb/CrystalStructure/UnitCell.h"
#include "discamb/Scattering/HansenCoppensStructureFactorCalculator.h"

#include <complex>

class TestCpuGpu: public Test
{
public:
    TestCpuGpu();
    virtual ~TestCpuGpu();
    virtual bool run_test(std::string &message, const std::vector<std::string> &arguments);
    virtual bool run_test(std::string &message) { return run_test(message, std::vector<std::string>()); };
    virtual std::string test_name() const { return std::string("Multipolar model structure factors and gradient for large molecules -  comparison between CPU and GPU results"); };

private:
    
    bool calculateAndCompare(std::string xdMas, std::string xdInp, std::string hklFile, const std::vector<std::complex<double> > &dTarget_dF);
    bool compare(const std::vector<std::complex<double> > &f1, 
                 const std::vector<std::complex<double> > &f2,
                 const std::vector<discamb::TargetFunctionAtomicParamDerivatives> &dTarg_dParam1,
                 const std::vector<discamb::TargetFunctionAtomicParamDerivatives> &dTarg_dParam2);
    bool compareDerivatives(const std::string &label, const std::vector<double> &d1, const std::vector<double> &d2);

    size_t mN_Cores;

};

#endif /*_DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_CPUGPU_H_*/
