#ifndef _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLAR_H_
#define _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLAR_H_
#include "Test.h"

#include "discamb/MathUtilities/Vector3.h"
#include "discamb/MathUtilities/Matrix3.h"

#include "discamb/CrystalStructure/Crystal.h"
#include "discamb/Scattering/HansenCoppensStructureFactorCalculator.h"

#include <vector>
#include <complex>


class TestMultipolar: public Test
{
public:
    TestMultipolar();
    virtual ~TestMultipolar();
    /*
    if no arguments are specified, it is assumed that the data for tests are in default location
    some_path/scattering/tests/correctness/test_1/data/
    the data files which are used by the test are:
        test_multipolar.inp in the data directory
        xd files in subfolder /structure_data/xd/
        structure factors data in subfolder /structure_factors/HC/
    if any of the arguments is specified it is assumed, that .. 
    -dir=path - directory searched for data
    -one_dir
    */
    virtual bool run_test(std::string &message, const std::vector<std::string> &arguments);
    virtual bool run_test(std::string &message);
    virtual std::string test_name() const { return std::string("multipolar SF calculation"); };

private:
    std::string mEngineId;
    std::string mDataDirectory;
    //bool mOneDirectory;
    int mN_Threads;
    double calc_R(const std::string &mx_mas_file, const std::string &xd_inp_file, const std::string &hkl_file,bool print_diff);
    double mRFactorThreshold;
    void printDifference(const std::string &xd_mas_file_name, std::vector<discamb::Vector3i> &hkl,
                         std::vector<std::complex<double> > &ref_f, std::vector<std::complex<double> > &f);
    bool run_test(std::string &message, bool useDefaultPaths);
};

#endif /*_DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLAR_H_*/
