#ifndef _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAM_H_
#define _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAM_H_
#include "Test.h"

#include "discamb/MathUtilities/Vector3.h"
#include "discamb/MathUtilities/Matrix3.h"

#include "discamb/CrystalStructure/Crystal.h"

#include <vector>
#include <complex>


class TestMultipolarAsIAM : public Test
{
public:
    TestMultipolarAsIAM();
    virtual ~TestMultipolarAsIAM();
    virtual bool run_test(std::string &message);
    virtual std::string test_name() const { return std::string("multipolar as IAM SF calculation"); };

private:
    int mN_Threads;
    double calc_R(const std::string &mx_mas_file, const std::string &xd_inp_file, 
                  const std::string &structureFile, const std::string &hkl_file, bool print_diff);
    double mRFactorThreshold;
    void printDifference(const std::string &xd_mas_file_name, std::vector<discamb::Vector3i> &hkl,
                         std::vector<std::complex<double> > &ref_f, std::vector<std::complex<double> > &f);
};

#endif /*_DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAM_H_*/
