#ifndef _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAMGRADIENTLARGE_H_
#define _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAMGRADIENTLARGE_H_
#include "Test_GradientLarge.h"
#include "discamb/CrystalStructure/UnitCell.h"

#include <complex>

class TestMultipolarAsIamGradientLarge : public TestGradientLarge
{
public:
    TestMultipolarAsIamGradientLarge();
    virtual ~TestMultipolarAsIamGradientLarge();
    virtual std::string test_name() const { return std::string("Multipolar as IAM gradient for large molecules"); };
    virtual std::string dataDirName() const { return "gradient/multipolar_large"; }
    virtual std::string inputFileName() const { return "test_multipolar_as_iam_gradient_large.inp"; }
protected:
    //virtual std::string structureFilesDir() const;
    std::string mDataDirectory;
    virtual std::string gradientFilesDir() const;
    virtual void readStructureAndCalculateDerivatives(
        bool customDir, const std::string &customDirPath,
        const std::vector<std::string> &structureFileNames,
        const std::vector<discamb::Vector3i> &hkl,
        const std::vector<std::complex<double> > &dTarget_dF,
        discamb::Crystal &crystal,
        std::vector<discamb::TargetFunctionAtomicParamDerivatives> &dTarg_dParam);

    virtual void readInputFile(const std::string &inputFileName,
                               std::string &dTarget_dF_file,
                               std::vector<std::vector<std::string> > &structureFiles,
                               std::vector<std::string> &hklFiles,
                               std::vector<std::string> &gradientFiles);
private:
    size_t mN_Cores;
};

#endif /*_DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAMGRADIENTLARGE_H_*/
