#ifndef _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAMGRADIENTSMALL_H_
#define _DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAMGRADIENTSMALL_H_
#include "Test_GradientSmall.h"
#include "discamb/CrystalStructure/UnitCell.h"

#include <complex>

class TestMultipolarAsIamGradientSmall : public TestGradientSmall
{
public:
    TestMultipolarAsIamGradientSmall();
    virtual ~TestMultipolarAsIamGradientSmall();
    virtual std::string test_name() const { return std::string("Multipolar as IAM gradient for small molecules"); };
    virtual std::string dataDirName() const { return "gradient/multipolar_small"; }
    virtual std::string inputFileName() const { return "test_multipolar_as_iam_gradient_small.inp"; };
    virtual std::string hklAndGradientDirName() const { return "gradient_data/small_molecule/iam"; };

protected:
    virtual void calculateGradientData(const std::vector<std::string> &structureFiles, const std::vector<discamb::Vector3i> &hkl,
                                       std::vector<std::complex<double> > &structureFactors, GradientDataSM_AllConventions &gradientData) const;

};

#endif /*_DISCAMB_TESTS_CORRECTNESS_TEST_1_TEST_MULTIPOLARASIAMGRADIENTSMALL_H_*/
