import os
import iotbx.cif
from cctbx import adptbx


def print_conversions( file_name ):
    crystal_structures = iotbx.cif.reader(file_name).build_crystal_structures()
    cif_data_sets = crystal_structures.keys()
    print cif_data_sets
    print cif_data_sets[0]

    structure_0 = crystal_structures[cif_data_sets[0]]

    scatterers = structure_0.scatterers()

    f = open(file_name[:-3]+'conv','w')

    unit_cell=structure_0.unit_cell()

    print >> f, "unit cell ", ("%8.6f " * 5 + "%8.6f") % unit_cell.parameters()
    
    print >> f, "n scatterers ", len(scatterers)
    '''
    U_iso
      1         2             3        4 5 6     7        8
    label scattering_type multiplicity x y z occupation u_iso [-]
    
    U_aniso
      1         2             3        4 5 6     7        8
    label scattering_type multiplicity x y z occupation  [-]
    '''
    for sc in scatterers:
        print >> f, "%-4s" % sc.label,
        print >> f, "%12.7f %12.7f %12.7f" % sc.site,
        print >> f, "%12.7f %12.7f %12.7f" % unit_cell.orthogonalize(sc.site),
        if sc.flags.use_u_aniso():
            assert unit_cell is not None
            print >> f, ("%16.12f " * 5 + "%16.12f") % sc.u_star,            
            u_cif = adptbx.u_star_as_u_cif(unit_cell, sc.u_star)
            print >> f, ("%16.12f " * 5 + "%16.12f") % u_cif,
            u_cart = adptbx.u_star_as_u_cart(unit_cell, sc.u_star)
            print >> f, ("%16.12f " * 5 + "%16.12f") % u_cart,            
        print >> f

    f.close()

files = [f for f in os.listdir('.') if os.path.isfile(f)]

file_list = []

for f in files:
    if f.endswith('.cif'):
        print_conversions(f)